// Code generated by client-gen. DO NOT EDIT.

package v1

import (
	"context"

	v1 "github.com/loft-sh/api/v4/pkg/apis/management/v1"
	scheme "github.com/loft-sh/api/v4/pkg/clientset/versioned/scheme"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	types "k8s.io/apimachinery/pkg/types"
	watch "k8s.io/apimachinery/pkg/watch"
	gentype "k8s.io/client-go/gentype"
)

// VirtualClusterInstancesGetter has a method to return a VirtualClusterInstanceInterface.
// A group's client should implement this interface.
type VirtualClusterInstancesGetter interface {
	VirtualClusterInstances(namespace string) VirtualClusterInstanceInterface
}

// VirtualClusterInstanceInterface has methods to work with VirtualClusterInstance resources.
type VirtualClusterInstanceInterface interface {
	Create(ctx context.Context, virtualClusterInstance *v1.VirtualClusterInstance, opts metav1.CreateOptions) (*v1.VirtualClusterInstance, error)
	Update(ctx context.Context, virtualClusterInstance *v1.VirtualClusterInstance, opts metav1.UpdateOptions) (*v1.VirtualClusterInstance, error)
	Delete(ctx context.Context, name string, opts metav1.DeleteOptions) error
	DeleteCollection(ctx context.Context, opts metav1.DeleteOptions, listOpts metav1.ListOptions) error
	Get(ctx context.Context, name string, opts metav1.GetOptions) (*v1.VirtualClusterInstance, error)
	List(ctx context.Context, opts metav1.ListOptions) (*v1.VirtualClusterInstanceList, error)
	Watch(ctx context.Context, opts metav1.ListOptions) (watch.Interface, error)
	Patch(ctx context.Context, name string, pt types.PatchType, data []byte, opts metav1.PatchOptions, subresources ...string) (result *v1.VirtualClusterInstance, err error)
	GetKubeConfig(ctx context.Context, virtualClusterInstanceName string, virtualClusterInstanceKubeConfig *v1.VirtualClusterInstanceKubeConfig, opts metav1.CreateOptions) (*v1.VirtualClusterInstanceKubeConfig, error)
	GetAccessKey(ctx context.Context, virtualClusterInstanceName string, options metav1.GetOptions) (*v1.VirtualClusterAccessKey, error)
	GetExternalDatabase(ctx context.Context, virtualClusterInstanceName string, virtualClusterExternalDatabase *v1.VirtualClusterExternalDatabase, opts metav1.CreateOptions) (*v1.VirtualClusterExternalDatabase, error)

	VirtualClusterInstanceExpansion
}

// virtualClusterInstances implements VirtualClusterInstanceInterface
type virtualClusterInstances struct {
	*gentype.ClientWithList[*v1.VirtualClusterInstance, *v1.VirtualClusterInstanceList]
}

// newVirtualClusterInstances returns a VirtualClusterInstances
func newVirtualClusterInstances(c *ManagementV1Client, namespace string) *virtualClusterInstances {
	return &virtualClusterInstances{
		gentype.NewClientWithList[*v1.VirtualClusterInstance, *v1.VirtualClusterInstanceList](
			"virtualclusterinstances",
			c.RESTClient(),
			scheme.ParameterCodec,
			namespace,
			func() *v1.VirtualClusterInstance { return &v1.VirtualClusterInstance{} },
			func() *v1.VirtualClusterInstanceList { return &v1.VirtualClusterInstanceList{} }),
	}
}

// GetKubeConfig takes the representation of a virtualClusterInstanceKubeConfig and creates it.  Returns the server's representation of the virtualClusterInstanceKubeConfig, and an error, if there is any.
func (c *virtualClusterInstances) GetKubeConfig(ctx context.Context, virtualClusterInstanceName string, virtualClusterInstanceKubeConfig *v1.VirtualClusterInstanceKubeConfig, opts metav1.CreateOptions) (result *v1.VirtualClusterInstanceKubeConfig, err error) {
	result = &v1.VirtualClusterInstanceKubeConfig{}
	err = c.GetClient().Post().
		Namespace(c.GetNamespace()).
		Resource("virtualclusterinstances").
		Name(virtualClusterInstanceName).
		SubResource("kubeconfig").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(virtualClusterInstanceKubeConfig).
		Do(ctx).
		Into(result)
	return
}

// GetAccessKey takes name of the virtualClusterInstance, and returns the corresponding v1.VirtualClusterAccessKey object, and an error if there is any.
func (c *virtualClusterInstances) GetAccessKey(ctx context.Context, virtualClusterInstanceName string, options metav1.GetOptions) (result *v1.VirtualClusterAccessKey, err error) {
	result = &v1.VirtualClusterAccessKey{}
	err = c.GetClient().Get().
		Namespace(c.GetNamespace()).
		Resource("virtualclusterinstances").
		Name(virtualClusterInstanceName).
		SubResource("accesskey").
		VersionedParams(&options, scheme.ParameterCodec).
		Do(ctx).
		Into(result)
	return
}

// GetExternalDatabase takes the representation of a virtualClusterExternalDatabase and creates it.  Returns the server's representation of the virtualClusterExternalDatabase, and an error, if there is any.
func (c *virtualClusterInstances) GetExternalDatabase(ctx context.Context, virtualClusterInstanceName string, virtualClusterExternalDatabase *v1.VirtualClusterExternalDatabase, opts metav1.CreateOptions) (result *v1.VirtualClusterExternalDatabase, err error) {
	result = &v1.VirtualClusterExternalDatabase{}
	err = c.GetClient().Post().
		Namespace(c.GetNamespace()).
		Resource("virtualclusterinstances").
		Name(virtualClusterInstanceName).
		SubResource("externaldatabase").
		VersionedParams(&opts, scheme.ParameterCodec).
		Body(virtualClusterExternalDatabase).
		Do(ctx).
		Into(result)
	return
}
