// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	managementv1 "github.com/loft-sh/api/v4/pkg/apis/management/v1"
	versioned "github.com/loft-sh/api/v4/pkg/clientset/versioned"
	internalinterfaces "github.com/loft-sh/api/v4/pkg/informers/externalversions/internalinterfaces"
	v1 "github.com/loft-sh/api/v4/pkg/listers/management/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// IngressAuthTokenInformer provides access to a shared informer and lister for
// IngressAuthTokens.
type IngressAuthTokenInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.IngressAuthTokenLister
}

type ingressAuthTokenInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewIngressAuthTokenInformer constructs a new informer for IngressAuthToken type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewIngressAuthTokenInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredIngressAuthTokenInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredIngressAuthTokenInformer constructs a new informer for IngressAuthToken type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredIngressAuthTokenInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ManagementV1().IngressAuthTokens().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ManagementV1().IngressAuthTokens().Watch(context.TODO(), options)
			},
		},
		&managementv1.IngressAuthToken{},
		resyncPeriod,
		indexers,
	)
}

func (f *ingressAuthTokenInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredIngressAuthTokenInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *ingressAuthTokenInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&managementv1.IngressAuthToken{}, f.defaultInformer)
}

func (f *ingressAuthTokenInformer) Lister() v1.IngressAuthTokenLister {
	return v1.NewIngressAuthTokenLister(f.Informer().GetIndexer())
}
