// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	managementv1 "github.com/loft-sh/api/v4/pkg/apis/management/v1"
	versioned "github.com/loft-sh/api/v4/pkg/clientset/versioned"
	internalinterfaces "github.com/loft-sh/api/v4/pkg/informers/externalversions/internalinterfaces"
	v1 "github.com/loft-sh/api/v4/pkg/listers/management/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// OwnedAccessKeyInformer provides access to a shared informer and lister for
// OwnedAccessKeys.
type OwnedAccessKeyInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.OwnedAccessKeyLister
}

type ownedAccessKeyInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
}

// NewOwnedAccessKeyInformer constructs a new informer for OwnedAccessKey type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewOwnedAccessKeyInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredOwnedAccessKeyInformer(client, resyncPeriod, indexers, nil)
}

// NewFilteredOwnedAccessKeyInformer constructs a new informer for OwnedAccessKey type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredOwnedAccessKeyInformer(client versioned.Interface, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ManagementV1().OwnedAccessKeys().List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.ManagementV1().OwnedAccessKeys().Watch(context.TODO(), options)
			},
		},
		&managementv1.OwnedAccessKey{},
		resyncPeriod,
		indexers,
	)
}

func (f *ownedAccessKeyInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredOwnedAccessKeyInformer(client, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *ownedAccessKeyInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&managementv1.OwnedAccessKey{}, f.defaultInformer)
}

func (f *ownedAccessKeyInformer) Lister() v1.OwnedAccessKeyLister {
	return v1.NewOwnedAccessKeyLister(f.Informer().GetIndexer())
}
