// Code generated by informer-gen. DO NOT EDIT.

package v1

import (
	"context"
	time "time"

	storagev1 "github.com/loft-sh/api/v4/pkg/apis/storage/v1"
	versioned "github.com/loft-sh/api/v4/pkg/clientset/versioned"
	internalinterfaces "github.com/loft-sh/api/v4/pkg/informers/externalversions/internalinterfaces"
	v1 "github.com/loft-sh/api/v4/pkg/listers/storage/v1"
	metav1 "k8s.io/apimachinery/pkg/apis/meta/v1"
	runtime "k8s.io/apimachinery/pkg/runtime"
	watch "k8s.io/apimachinery/pkg/watch"
	cache "k8s.io/client-go/tools/cache"
)

// VirtualClusterInstanceInformer provides access to a shared informer and lister for
// VirtualClusterInstances.
type VirtualClusterInstanceInformer interface {
	Informer() cache.SharedIndexInformer
	Lister() v1.VirtualClusterInstanceLister
}

type virtualClusterInstanceInformer struct {
	factory          internalinterfaces.SharedInformerFactory
	tweakListOptions internalinterfaces.TweakListOptionsFunc
	namespace        string
}

// NewVirtualClusterInstanceInformer constructs a new informer for VirtualClusterInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewVirtualClusterInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers) cache.SharedIndexInformer {
	return NewFilteredVirtualClusterInstanceInformer(client, namespace, resyncPeriod, indexers, nil)
}

// NewFilteredVirtualClusterInstanceInformer constructs a new informer for VirtualClusterInstance type.
// Always prefer using an informer factory to get a shared informer instead of getting an independent
// one. This reduces memory footprint and number of connections to the server.
func NewFilteredVirtualClusterInstanceInformer(client versioned.Interface, namespace string, resyncPeriod time.Duration, indexers cache.Indexers, tweakListOptions internalinterfaces.TweakListOptionsFunc) cache.SharedIndexInformer {
	return cache.NewSharedIndexInformer(
		&cache.ListWatch{
			ListFunc: func(options metav1.ListOptions) (runtime.Object, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.StorageV1().VirtualClusterInstances(namespace).List(context.TODO(), options)
			},
			WatchFunc: func(options metav1.ListOptions) (watch.Interface, error) {
				if tweakListOptions != nil {
					tweakListOptions(&options)
				}
				return client.StorageV1().VirtualClusterInstances(namespace).Watch(context.TODO(), options)
			},
		},
		&storagev1.VirtualClusterInstance{},
		resyncPeriod,
		indexers,
	)
}

func (f *virtualClusterInstanceInformer) defaultInformer(client versioned.Interface, resyncPeriod time.Duration) cache.SharedIndexInformer {
	return NewFilteredVirtualClusterInstanceInformer(client, f.namespace, resyncPeriod, cache.Indexers{cache.NamespaceIndex: cache.MetaNamespaceIndexFunc}, f.tweakListOptions)
}

func (f *virtualClusterInstanceInformer) Informer() cache.SharedIndexInformer {
	return f.factory.InformerFor(&storagev1.VirtualClusterInstance{}, f.defaultInformer)
}

func (f *virtualClusterInstanceInformer) Lister() v1.VirtualClusterInstanceLister {
	return v1.NewVirtualClusterInstanceLister(f.Informer().GetIndexer())
}
